<?php
require __DIR__ . "/vendor/autoload.php";
require __DIR__ . "/vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/vendor/teknisa/libraries/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes = array();
$routes[] = __DIR__ . '/routes.json';
$routes[] = __DIR__ . '/vendor/teknisa/libraries/libRoutes.json';
$routes[] = __DIR__ . "/vendor/zeedhi/preferences/routes.json";

$instanceManager->loadFromFile('../config/db.xml');
$instanceManager->loadFromFile('../config/parameters.xml');
$instanceManager->loadFromFile('../config/environment.xml');
$instanceManager->loadFromFile('../config/services.xml');
$instanceManager->loadFromFile('../config/controllers.xml');

$container = $instanceManager->getContainer();

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();