function MyMenuInformativosController(ScreenService, templateManager, General) {

    this.backToLastWidget = function (widget) {
        let widgets = widget.container.widgets;
        let acwidget = widgets.indexOf(widget);

        widget.isVisible = false;

        let widgetToGo = widgets[acwidget - 1];

        widgetToGo.container.label = widgetToGo.servdata ? widgetToGo.servdata[widgetToGo.label] : null || widgetToGo.currentRow.servdata ? widgetToGo.currentRow.servdata[widgetToGo.label] : widgetToGo.label;

        widgetToGo.isVisible = true;
        widgetToGo.activate();
        if(isBackButtonListenerAttached){
            document.removeEventListener('backbutton', goBackListener);
            isBackButtonListenerAttached = false;
        }
    };

    var isBackButtonListenerAttached = false;

    let goBackListener = () => {
        const widget = templateManager.container.getWidget('openInformativo');
        this.backToLastWidget(widget);
    };

    this.bindBackButtonListener = () => {
        if('cordova' in window){
            isBackButtonListenerAttached = true;
            document.addEventListener('backbutton', goBackListener);
        }
    };

    this.getInformStatus = (container) => {
        let lastAccs = getLocalVar('lastAccessOnApp') || null;
        container.label =  getLocalVar('DSNOMEEXIBICAO') || ScreenService.i18n('Início');
        General.callRestEngine("/lastAccessOnApp", "Row", {
            'lastAccs': moment(lastAccs, 'DD/MM/YYYY HH:mm:ss').format('YYYYMMDDHHmmss')
        }).then(function (response) {
            let unread = response.dataset.count.count;
            let inforFooter = document.getElementById('rui-footer-element-informativos');
            if (unread > 0 && inforFooter) {
                inforFooter.classList.add('dot-of-new');
            }
        });
        let userData = getLocalVar('userData');
        container.getWidget('mainWidget').getAction('changePasswd').isVisible = !(userData && (userData.isAnon === true || userData.isFacebookConnected === true));

        
        if('FirebasePlugin' in window){
            window.FirebasePlugin.confirmListenerAttached();
        }
    };
    this.clearInformStatus = (container) => {
        let lastAccs = moment().format('DD/MM/YYYY HH:mm:ss');
        setLocalVar('lastAccessOnApp', lastAccs);
        let inforFooter = document.getElementById('rui-footer-element-informativos');
        if (inforFooter) {
            inforFooter.classList.remove('dot-of-new');
        }
    };

    this.openPendingDetails = () => {
        if(window.__pendingDetails){
            const informativoWidget = templateManager.container.getWidget("mainWidget");
            let informativoDetails = informativoWidget.dataSource.data.find(e => e.NRINFORMATIVO === window.__NRINFORMATIVO);
            if(informativoDetails){
                informativoWidget.goToDetails(informativoDetails, informativoWidget);
            }
            window.__pendingDetails = false;
        }
    };

    this.openInformativoFromPushNotification = (event) => {
        let details = event.detail;
        if(details.NRINFORMATIVO){
            if(templateManager.container.name !== "informativos") {
                openWindow("informativos");
                window.__pendingDetails = true;    
                window.__NRINFORMATIVO = details.NRINFORMATIVO;    
            } else {
                const informativoWidget = templateManager.container.getWidget("mainWidget");
                let informativoDetails = informativoWidget.dataSource.data.find(e => e.NRINFORMATIVO === details.NRINFORMATIVO);
                if(informativoDetails){
                    informativoWidget.goToDetails(informativoDetails, informativoWidget);
                }
            }
        } else {
            if (details.title) {
                ScreenService.showMessage(details.title + "<br>" + details.body);
            }
        }
    };

    document.addEventListener('notificationopen', this.openInformativoFromPushNotification);

}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyMenuInformativosController', MyMenuInformativosController);
});