let FCMBootstrap = function() {

    /**
     * @param {string} topic 
     */
    let unsubscribe = (topic) => {
        return new Promise((resolve, reject) => {
            if('FirebasePlugin' in window){
                FirebasePlugin.unsubscribe(topic, (s) => {
                    localStorage.removeItem("subscribedTopic");
                    resolve(s);
                }, (e) => reject(e));
            } else {
                reject();
            }
        });
    };

    /**
     * @param {string} topic 
     */
    let subscribe = (topic) => {
        return new Promise((resolve, reject) => {
            if('FirebasePlugin' in window){
                FirebasePlugin.subscribe(topic, (s) =>{ 
                    localStorage.setItem("subscribedTopic", topic);
                    resolve(s);
                }, (e) => reject(e));
            } else {
                reject();
            }
        });
    };

    this.start = () => {
        let qrCodeData = getLocalVar('qrCodeData');
        let customerID = getLocalVar('customerID');

        if(qrCodeData && customerID){
            let subscribedTopic = localStorage.getItem("subscribedTopic");
            let newTopicName = customerID + "_" + qrCodeData.nrorg + "_" + qrCodeData.nrqrcode;
            if(subscribedTopic){
                return unsubscribe(subscribedTopic).then(() => subscribe(newTopicName));
            } else {
                return subscribe(newTopicName);
            }
        } else {
            return Promise.reject();
        }

    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('FCMBootstrap', FCMBootstrap);
});
